/**
 * Copyright (C) 2011  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.extension;

import org.ow2.orchestra.definition.BpelProcess;
import org.ow2.orchestra.xml.Parse;
import org.ow2.orchestra.xml.Parser;
import org.w3c.dom.Element;


/**
 * @author manhtoan
 */
public interface ExtensionProvider {
  /**
   * key to use to find an object in the wiring context.
   */
  String DEFAULT_KEY = "extensionProvider";

  /**
   * Parse an extension element
   *
   * @param element the element need to be parse
   * @param parse
   * @return the Orchestra node Node
   */
  Object parse(Element element, Parse parse, Parser parser);

  /**
   * @return if this extension is supported by orchestra
   */
  boolean isSupported(String namespace);

  /*
 * Deploy the needed external module
 * */
  void deployExternalModule(BpelProcess bpelProcess);
}
