/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.facade.def.full;

import org.ow2.orchestra.facade.def.ExtensionDefinition;
import org.ow2.orchestra.facade.def.ProcessDefinition;
import org.ow2.orchestra.facade.def.ProcessState;
import org.ow2.orchestra.services.Archivable;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author Gael Lalire
 */
public interface ProcessFullDefinition extends ScopeActivityFullDefinition, ProcessDefinition, Archivable {

  void setUndeployedDate(final Date undeployedDate);

  void setVersion(final int version);

  void setState(final Date date, final ProcessState state);

  ProcessFullDefinition fullCopy();

  void setExtensions(List<ExtensionDefinition> extensions);

  /**
   * @return the process resources deployed with the process (BPEL, WSDL, BPMN source files...)
   */
  Map<String, byte[]> getProcessResources();

  void setProcessResources(Map<String, byte[]> resources);
}


