/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.jmx;

import java.util.concurrent.ThreadPoolExecutor;


/**
 * @author Guillaume Porcher
 *
 */
public class ManagedThreadPool implements ManagedThreadPoolMBean {

  private final ThreadPoolExecutor threadPoolExecutor;


  public ManagedThreadPool(final ThreadPoolExecutor threadPoolExecutor) {
    this.threadPoolExecutor = threadPoolExecutor;
  }

  public int getActiveCount() {
    return this.threadPoolExecutor.getActiveCount();
  }
  public long getCompletedTaskCount() {
    return this.threadPoolExecutor.getCompletedTaskCount();
  }
  public int getCorePoolSize() {
    return this.threadPoolExecutor.getCorePoolSize();
  }
  public int getPoolSize() {
    return this.threadPoolExecutor.getPoolSize();
  }
  public long getTaskCount() {
    return this.threadPoolExecutor.getTaskCount();
  }
  public int getWaitingTaskCount() {
    return this.threadPoolExecutor.getQueue().size();
  }
  public void setCorePoolSize(final int corePoolSize) {
    this.threadPoolExecutor.setCorePoolSize(corePoolSize);
    this.threadPoolExecutor.setMaximumPoolSize(corePoolSize);
  }

}
