package org.ow2.orchestra.persistence.db.hibernate;

import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;

import org.hibernate.usertype.UserType;

public class URLUserType implements UserType {

  private static final int[] SQL_TYPES = new int[] { Types.VARCHAR };

  public Object assemble(final Serializable cached, final Object owner) {
    return cached;
  }

  public Object deepCopy(final Object o) {
    return o;
  }

  public Serializable disassemble(final Object o) {
    return (Serializable) o;
  }

  public boolean equals(final Object x, final Object y) {
    if (x == null) {
      return y == null;
    }
    return x.equals(y);
  }

  public int hashCode(final Object o) {
    return o.hashCode();
  }

  public boolean isMutable() {
    return false;
  }

  public Object nullSafeGet(final ResultSet resultSet, final String[] names, final Object owner)
    throws SQLException {
    final String urlAsString = resultSet.getString(names[0]);
    try {
      return new URL(urlAsString);
    } catch (final MalformedURLException e) {
      return null;
    }
  }

  public void nullSafeSet(final PreparedStatement preparedStatement, final Object value,
      final int index) throws SQLException {
    if (value != null) {
      final URL url = (URL) value;
      preparedStatement.setString(index, url.toExternalForm());
    }
  }

  public Object replace(final Object original, final Object target, final Object owner) {
    return target;
  }

  public Class<URL> returnedClass() {
    return URL.class;
  }

  public int[] sqlTypes() {
    return URLUserType.SQL_TYPES;
  }

}
