/*******************************************************************************
 * Copyright (C) 2011  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 *******************************************************************************/
package org.ow2.orchestra.runtime;

/**
 * @author Guillaume Porcher
 */
public class MessageExchangeRuntime {
  protected String messageExchangeId;

  /** Default constructor for Hibernate */
  protected MessageExchangeRuntime() {}

  public MessageExchangeRuntime(final String messageExchange, ScopeRuntime scopeRuntime) {
    this.messageExchangeId = messageExchange + scopeRuntime.getActivityInstanceUUID();
  }

  public String getMessageExchangeId() {
    return messageExchangeId;
  }

  @Override
  public String toString() {
    return messageExchangeId;
  }

  @Override
  public boolean equals(final Object o) {
    if (this == o) {
      return true;
    }
    if (!(o instanceof MessageExchangeRuntime)) {
      return false;
    }

    final MessageExchangeRuntime that = (MessageExchangeRuntime) o;

    if (!messageExchangeId.equals(that.messageExchangeId)) {
      return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    return messageExchangeId.hashCode();
  }
}
