/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.services;

import org.ow2.orchestra.runtime.MessageExchangeRuntime;

public class OpenIMAKey {

  protected OperationKey operationKey;

  protected MessageExchangeRuntime messageExchangeRuntime;

  protected OpenIMAKey() {
  }

  public OpenIMAKey(final OperationKey operationKey, final MessageExchangeRuntime messageExchangeRuntime) {
    this.operationKey = operationKey;
    this.messageExchangeRuntime = messageExchangeRuntime;
  }

  @Override
  public int hashCode() {
    return this.toString().hashCode();
  }

  @Override
  public boolean equals(final Object obj) {
    if (obj == null || !(obj instanceof OpenIMAKey)) {
      return false;
    }
    final OpenIMAKey other = (OpenIMAKey) obj;
    final OperationKey otherOpKey = other.getOperationKey();
    return otherOpKey.equals(this.operationKey)
        && other.getMessageExchangeRuntime().equals(this.messageExchangeRuntime);
  }

  public OperationKey getOperationKey() {
    return this.operationKey;
  }

  public MessageExchangeRuntime getMessageExchangeRuntime() {
    return this.messageExchangeRuntime;
  }

  @Override
  public String toString() {
    return "OpenIMAKey : "
           + "OperationKey = " + this.operationKey +", "
           + "MessageExchange = " + this.messageExchangeRuntime;
  }
}
